package testw32apianno;
import utildll.*;
public class TestW32API11 {
	static final int CHARSET = Arg.UNICODE;
	//static final int CHARSET = Arg.ANSI;
	
	final int ERROR_SUCCESS = 0;
	final int ERROR_ACCESS_DENIED = 5;
	int intErrNum_RegOpenKeyEx = 0;
	int intErrNum_RegCloseKey = 0;
	int intErrNum_RegQueryInfoKey = 0;
	int intErrNum_RegEnumValue = 0;
	int intErrNum_RegEnumKeyEx = 0;
	int intErrNum_RegQueryValueEx = 0;
	String strErrLog[] = new String[500];
	int intErrLogNum = 0;
	String strLevelName[] = new String[100];
	int intLevelNum = 0;
	
	public static void main(String[] args) {
		new TestW32API11();
	}

	TestW32API11() {
		int intRtnVal;

		Arg_RegOpenKeyEx aroke = new Arg_RegOpenKeyEx(WinReg_h.HKEY_LOCAL_MACHINE,
				"SYSTEM\\CurrentControlSet\\Control");
		
		intRtnVal = JInvoker.callIntProc("RegOpenKeyEx", "advapi32", aroke);

		//System.out.println("RegOpenKeyEx rtn: " + Integer.toString(intRtnVal)
		//		+ " LastError:" + Integer.toString(aroke.getLastError()));
		//System.out.println("phkResult rtn: " + Integer.toString(aroke.gethkResult()));
		if (intRtnVal != ERROR_SUCCESS) {
			intErrNum_RegOpenKeyEx++;
			logErr("RegOpenKeyEx", intRtnVal, "");
		}
		
		int inthKey = aroke.gethkResult();
		
		enumRegistry(inthKey, 0);
		
		Arg_RegCloseKey arck = new Arg_RegCloseKey(inthKey);	
		
		intRtnVal = JInvoker.callIntProc("RegCloseKey", "advapi32", arck);

		//System.out.println("RegCloseKey rtn: " + Integer.toString(intRtnVal)
		//		+ " LastError:" + Integer.toString(arck.getLastError()));
		if (intRtnVal != ERROR_SUCCESS) {
			intErrNum_RegCloseKey++;
			logErr("RegCloseKey", intRtnVal, "");
		}
	
		System.out.println("intErrNum_RegOpenKeyEx: " + Integer.toString(intErrNum_RegOpenKeyEx));
		System.out.println("intErrNum_RegCloseKey: " + Integer.toString(intErrNum_RegCloseKey));
		System.out.println("intErrNum_RegQueryInfoKey: " + Integer.toString(intErrNum_RegQueryInfoKey));
		System.out.println("intErrNum_RegEnumValue: " + Integer.toString(intErrNum_RegEnumValue));
		System.out.println("intErrNum_RegEnumKeyEx: " + Integer.toString(intErrNum_RegEnumKeyEx));
		System.out.println("intErrNum_RegQueryValueEx: " + Integer.toString(intErrNum_RegQueryValueEx));
		for (int i = 0; i < intErrLogNum; i++)
			System.out.println(strErrLog[i]);
	}
	
	
	void enumRegistry(int inthKey, int intLevel) {
		int intRtnVal;
		
		Arg_RegQueryInfoKey arqik = new Arg_RegQueryInfoKey(inthKey);	
		
		intRtnVal = JInvoker.callIntProc("RegQueryInfoKey", "advapi32", arqik);

		//System.out.println("RegQueryInfoKey rtn: " + Integer.toString(intRtnVal)
		//		+ " LastError:" + Integer.toString(arqik.getLastError()));
		//System.out.println("lpcSubKeys: " + Integer.toString(arqik.getSubKeys()));
		//System.out.println("lpcMaxSubKeyLen: " + Integer.toString(arqik.getMaxSubKeyLen()));
		//System.out.println("lpcValues: " + Integer.toString(arqik.getValues()));
		//System.out.println("lpcMaxValueNameLen: " + Integer.toString(arqik.getMaxValueNameLen()));
		if (intRtnVal != ERROR_SUCCESS) {
			intErrNum_RegQueryInfoKey++;
			logErr("RegQueryInfoKey", intRtnVal, "");
		}
		
		int intSubKeys = arqik.getSubKeys();
		int intMaxSubKeyLen = arqik.getMaxSubKeyLen();
		intMaxSubKeyLen = 260;//sȒ߂ߌŒ
		int intValues = arqik.getValues();
		int intMaxValueNameLen = arqik.getMaxValueNameLen();
		intMaxValueNameLen = 260;//sȒ߂ߌŒ
		
		String strLevel = "";
		for (int i = 0; i < intLevel; i++) strLevel += "|   ";
		
		for (int intIndex = 0; intIndex < intValues; intIndex++) {
			Arg_RegEnumValue arev = new Arg_RegEnumValue(inthKey, intIndex, intMaxValueNameLen + 1);	
			
			intRtnVal = JInvoker.callIntProc("RegEnumValue", "advapi32", arev);
	
			//System.out.println("RegEnumValue rtn: " + Integer.toString(intRtnVal)
			//		+ " LastError:" + Integer.toString(arev.getLastError()));
			if (intRtnVal != ERROR_SUCCESS) {
				intErrNum_RegEnumValue++;
				logErr("RegEnumValue", intRtnVal, Integer.toString(intIndex)
						+ "," + Integer.toString(intMaxValueNameLen));
			}
			
			String strName = arev.getValueName();
			if (strName.length() == 0)
				System.out.print(strLevel + "(W) = ");
			else
				System.out.print(strLevel + strName + " = ");
			
			getValue(inthKey, arev.getValueName());
		
		}
		
		for (int intIndex = 0; intIndex < intSubKeys; intIndex++) {
			Arg_RegEnumKeyEx areke = new Arg_RegEnumKeyEx(inthKey, intIndex, intMaxSubKeyLen + 1);	
			
			intRtnVal = JInvoker.callIntProc("RegEnumKeyEx", "advapi32", areke);
	
			//System.out.println("RegEnumKeyEx rtn: " + Integer.toString(intRtnVal)
			//		+ " LastError:" + Integer.toString(areke.getLastError()));
			if (intRtnVal != ERROR_SUCCESS) {
				intErrNum_RegEnumKeyEx++;
				logErr("RegEnumKeyEx", intRtnVal, Integer.toString(intIndex)
						+ "," + Integer.toString(intMaxSubKeyLen));
			}
			
			System.out.println(strLevel + "[" + areke.getName() + "]");
		
		
			Arg_RegOpenKeyEx aroke = new Arg_RegOpenKeyEx(inthKey, areke.getName());
	
			intRtnVal = JInvoker.callIntProc("RegOpenKeyEx", "advapi32", aroke);
		
			//System.out.println("RegOpenKeyEx rtn: " + Integer.toString(intRtnVal)
			//		+ " LastError:" + Integer.toString(aroke.getLastError()));
			//System.out.println("phkResult rtn: " + Integer.toString(aroke.gethkResult()));
			if (intRtnVal != ERROR_ACCESS_DENIED) {
				if (intRtnVal != ERROR_SUCCESS) {
					intErrNum_RegOpenKeyEx++;
					logErr("RegEnumKeyEx", intRtnVal, "");
				}
				
				int inthSubKey = aroke.gethkResult();
				
				strLevelName[intLevelNum] = areke.getName() + "\\";
				intLevelNum++;
				
				enumRegistry(inthSubKey, intLevel + 1);
				
				intLevelNum--;
				
				Arg_RegCloseKey arck = new Arg_RegCloseKey(inthSubKey);	
				
				intRtnVal = JInvoker.callIntProc("RegCloseKey", "advapi32", arck);
			
				//System.out.println("RegCloseKey rtn: " + Integer.toString(intRtnVal)
				//		+ " LastError:" + Integer.toString(arck.getLastError()));
				if (intRtnVal != ERROR_SUCCESS) {
					intErrNum_RegCloseKey++;
					logErr("RegCloseKey", intRtnVal, "");
				}
			}
		}
	}
	
	void getValue(int inthKey, String strVal) {
		int intRtnVal;
		
		Arg_RegQueryValueEx arqve = new Arg_RegQueryValueEx(inthKey, strVal);	
		
		intRtnVal = JInvoker.callIntProc("RegQueryValueEx", "advapi32", arqve);
		
		//System.out.println("RegQueryValueEx rtn: " + Integer.toString(intRtnVal)
		//		+ " LastError:" + Integer.toString(arqve.getLastError()));
		//System.out.println("Type: " + Integer.toString(arqve.getType())
		//		+ " Size: " + Integer.toString(arqve.getSize()));
		if (intRtnVal != ERROR_SUCCESS) {
			intErrNum_RegQueryValueEx++;
			logErr("RegQueryValueEx", intRtnVal, strVal);
		}
		switch(arqve.getType()) {
		case WinNT_h.REG_NONE:
			System.out.println("(NONE)");
			break;
		case WinNT_h.REG_SZ:
			arqve.initDataSZ(arqve.getSize() + 1);
			intRtnVal = JInvoker.callIntProc("RegQueryValueEx", "advapi32", arqve);
			if (intRtnVal != ERROR_SUCCESS) {
				intErrNum_RegQueryValueEx++;
				logErr("RegQueryValueEx", intRtnVal, strVal);
			}
			System.out.println("(SZ) " + arqve.getDataSZ());
			break;
		case WinNT_h.REG_EXPAND_SZ:
			arqve.initDataSZ(arqve.getSize() + 1);
			intRtnVal = JInvoker.callIntProc("RegQueryValueEx", "advapi32", arqve);
			if (intRtnVal != ERROR_SUCCESS) {
				intErrNum_RegQueryValueEx++;
				logErr("RegQueryValueEx", intRtnVal, strVal);
			}
			System.out.println("(EXPAND_SZ) " + arqve.getDataSZ());
			break;
		case WinNT_h.REG_BINARY:
			arqve.initDataBINARY(arqve.getSize());
			intRtnVal = JInvoker.callIntProc("RegQueryValueEx", "advapi32", arqve);
			if (intRtnVal != ERROR_SUCCESS) {
				intErrNum_RegQueryValueEx++;
				logErr("RegQueryValueEx", intRtnVal, strVal);
			}
			byte[] bytData = arqve.getDataBINARY();
			int intLen = bytData.length;
			System.out.print("(BINARY[" + Integer.toString(intLen) + "B]) ");
			if (intLen > 10) intLen = 10;
			for (int i = 0; i < intLen; i++) {
				String strByte = "0" + Integer.toHexString(bytData[i]) + " ";
				strByte = strByte.substring(strByte.length() - 3);
				System.out.print(strByte);
			}
			if (bytData.length > 10) System.out.print("...");
			System.out.println();
			break;
		case WinNT_h.REG_DWORD:
			arqve.initDataDWORD();
			intRtnVal = JInvoker.callIntProc("RegQueryValueEx", "advapi32", arqve);
			if (intRtnVal != ERROR_SUCCESS) {
				intErrNum_RegQueryValueEx++;
				logErr("RegQueryValueEx", intRtnVal, strVal);
			}
			System.out.println("(DWORD) 0x" + Integer.toHexString(arqve.getDataDWORD())
					 + " (" + Integer.toString(arqve.getDataDWORD())+ ")");
			break;
		case WinNT_h.REG_DWORD_BIG_ENDIAN:
			System.out.println("(DWORD_BIG_ENDIAN)");
			break;
		case WinNT_h.REG_LINK:
			System.out.println("(LINK)");
			break;
		case WinNT_h.REG_MULTI_SZ:
			arqve.initDataMULTI_SZ(arqve.getSize() + 1);
			intRtnVal = JInvoker.callIntProc("RegQueryValueEx", "advapi32", arqve);
			if (intRtnVal != ERROR_SUCCESS) {
				intErrNum_RegQueryValueEx++;
				logErr("RegQueryValueEx", intRtnVal, strVal);
			}
			System.out.println("(MULTI_SZ) " + arqve.getDataMULTI_SZ());
			break;
		case WinNT_h.REG_RESOURCE_LIST:
			System.out.println("(RESOURCE_LIST)");
			break;
		case WinNT_h.REG_FULL_RESOURCE_DESCRIPTOR:
			System.out.println("(FULL_RESOURCE_DESCRIPTOR)");
			break;
		case WinNT_h.REG_RESOURCE_REQUIREMENTS_LIST:
			System.out.println("(RESOURCE_REQUIREMENTS_LIST)");
			break;
		case WinNT_h.REG_QWORD:
			arqve.initDataQWORD();
			intRtnVal = JInvoker.callIntProc("RegQueryValueEx", "advapi32", arqve);
			if (intRtnVal != ERROR_SUCCESS) {
				intErrNum_RegQueryValueEx++;
				logErr("RegQueryValueEx", intRtnVal, strVal);
			}
			System.out.println("(QWORD) 0x" + Long.toHexString(arqve.getDataQWORD())
					 + " (" + Long.toString(arqve.getDataQWORD())+ ")");
			break;
		default:
			System.out.println("(unknown type)");
		}
		
	}
	
	void logErr(String strAPI, int intErr, String strName) {
		String strLog = strAPI + " " + Integer.toString(intErr) + " ";
		
		for (int i = 0; i < intLevelNum; i++)
			strLog += strLevelName[i];
		
		strLog += strName;
		strErrLog[intErrLogNum] = strLog;
		intErrLogNum++;
	}
	
	/*
	LONG RegQueryValueEx(
	  HKEY hKey,            // L[̃nh
	  LPCTSTR lpValueName,  // WXgGg
	  LPDWORD lpReserved,   // \ς
	  LPDWORD lpType,       // f[^^i[obt@
	  LPBYTE lpData,        // f[^i[obt@
	  LPDWORD lpcbData      // f[^obt@̃TCY
	);
	 */
	@_CharSet(CHARSET)
	class Arg_RegQueryValueEx {
		private int _LastError;
	
		private int hKey;
		private @_Const String lpValueName;
		private int[] lpReserved = null;
		private int[] lpType = new int[1];
		private @_Fixed Object lpData; //WXǧ^ɍf[^\ɕύX
		private int[] lpcbData = new int[1];
		
		Arg_RegQueryValueEx(int hKey, String lpValueName) {
			this.hKey = hKey;
			this.lpValueName = lpValueName;
			lpData = new Struct_DataDWORD();  //R[NULLZbg
		}
		void initDataDWORD() {
			Struct_DataDWORD lpDataDWORD = new Struct_DataDWORD();
			lpDataDWORD.DataDWORD = new int[1];
			lpData = lpDataDWORD;
			lpcbData[0] = 4;
		}
		void initDataSZ(int intSize) {
			Struct_DataSZ lpDataSZ = new Struct_DataSZ();
			StringBuffer sb = new StringBuffer(intSize);
			for (int i = 0; i < intSize; i++) {
				sb.append(' ');
			}
			lpDataSZ.DataSZ = sb.toString();
			lpData = lpDataSZ;
			lpcbData[0] = intSize;
		}
		void initDataMULTI_SZ(int intSize) {
			Struct_DataMULTI_SZ lpDataMULTI_SZ = new Struct_DataMULTI_SZ();
			StringBuffer sb = new StringBuffer(intSize);
			for (int i = 0; i < intSize; i++) {
				sb.append(' ');
			}
			lpDataMULTI_SZ.DataMULTI_SZ = sb.toString();
			lpData = lpDataMULTI_SZ;
			lpcbData[0] = intSize;
		}
		void initDataBINARY(int intSize) {
			Struct_DataBINARY lpDataBINARY = new Struct_DataBINARY();
			lpDataBINARY.DataBINARY = new  byte[intSize];
			lpData = lpDataBINARY;
			lpcbData[0] = intSize;
		}
		void initDataQWORD() {
			Struct_DataQWORD lpDataQWORD = new Struct_DataQWORD();
			lpDataQWORD.DataQWORD = new long[1];
			lpData = lpDataQWORD;
			lpcbData[0] = 8;
		}
		int getType() {return lpType[0];}
		int getSize() {return lpcbData[0];}
		int getDataDWORD() {
			Struct_DataDWORD lpDataDWORD = (Struct_DataDWORD)lpData;
			return lpDataDWORD.DataDWORD[0];
		}
		String getDataSZ() {
			Struct_DataSZ lpDataSZ = (Struct_DataSZ)lpData;
			return lpDataSZ.DataSZ;
		}
		String getDataMULTI_SZ() {
			Struct_DataMULTI_SZ lpDataMULTI_SZ = (Struct_DataMULTI_SZ)lpData;
			return lpDataMULTI_SZ.DataMULTI_SZ;
		}
		byte[] getDataBINARY() {
			Struct_DataBINARY lpDataBINARY = (Struct_DataBINARY)lpData;
			return lpDataBINARY.DataBINARY;
		}
		long getDataQWORD() {
			Struct_DataQWORD lpDataQWORD = (Struct_DataQWORD)lpData;
			return lpDataQWORD.DataQWORD[0];
		}
		int getLastError() {return _LastError;}
	}
	class Struct_DataDWORD {
		int[] DataDWORD;
	}
	class Struct_DataSZ {
		String DataSZ;
	}
	class Struct_DataMULTI_SZ {
		@_BStr String DataMULTI_SZ;
	}
	class Struct_DataBINARY {
		byte[] DataBINARY;
	}
	class Struct_DataQWORD {
		long[] DataQWORD;
	}
	
	/*
	LONG RegEnumKeyEx(
	  HKEY hKey,                  // 񋓂ׂL[̃nh
	  DWORD dwIndex,              // TuL[̃CfbNXԍ
	  LPTSTR lpName,              // TuL[i[obt@
	  LPDWORD lpcName,            // TuL[obt@̃TCY
	  LPDWORD lpReserved,         // \ς
	  LPTSTR lpClass,             // NXi[obt@
	  LPDWORD lpcClass,           // NXobt@̃TCY
	  PFILETIME lpftLastWriteTime // ŏIݎ
	);
	 */
	@_CharSet(CHARSET)
	class Arg_RegEnumKeyEx {
		private int _LastError;
	
		private int hKey;
		private int dwIndex;
		private String lpName;
		private int[] lpcName = new int[1];
		private int[] lpReserved = null;
		private String lpClass = null;
		private int[] lpcClass = null;
		private long[] lpftLastWriteTime = null;
		
		Arg_RegEnumKeyEx(int hKey, int dwIndex, int lpcName) {
			this.hKey = hKey;
			this.dwIndex = dwIndex;
			StringBuffer sb = new StringBuffer(lpcName);
			for (int i = 0; i < lpcName; i++) {
				sb.append(' ');
			}
			this.lpName = sb.toString();
			this.lpcName[0] = lpcName;
		}
		String getName() {return lpName;}
		int getLastError() {return _LastError;}
	}

	/*
	LONG RegEnumValue(
	  HKEY hKey,             // ₢킹Ώۂ̃L[̃nh
	  DWORD dwIndex,         // 擾ׂWXgGg̃CfbNXԍ
	  LPTSTR lpValueName,    // WXgGgi[obt@
	  LPDWORD lpcValueName,  // WXgGgobt@̃TCY
	  LPDWORD lpReserved,    // \ς
	  LPDWORD lpType,        // WXgGg̃f[^̃^Cv
	  LPBYTE lpData,         // WXgGg̃f[^i[obt@
	  LPDWORD lpcbData       // f[^obt@̃TCY
	);
	 */
	@_CharSet(CHARSET)
	class Arg_RegEnumValue {
		private int _LastError;
	
		private int hKey;
		private int dwIndex;
		private String lpValueName;
		private int[] lpcValueName = new int[1];
		private int[] lpReserved = null;
		private int[] lpType = null;
		private byte[] lpData = null;
		private int[] lpcbData = null;
		
		Arg_RegEnumValue(int hKey, int dwIndex, int lpcValueName) {
			this.hKey = hKey;
			this.dwIndex = dwIndex;
			StringBuffer sb = new StringBuffer(lpcValueName);
			for (int i = 0; i < lpcValueName; i++) {
				sb.append(' ');
			}
			this.lpValueName = sb.toString();
			this.lpcValueName[0] = lpcValueName;
		}
		String getValueName() {return lpValueName;}
		int getLastError() {return _LastError;}
	}
	
	/*
	LONG RegQueryInfoKey(
	  HKEY hKey,                      // ₢킹ׂL[̃nh
	  LPTSTR lpClass,                 // NXi[obt@
	  LPDWORD lpcClass,               // NXobt@̃TCY
	  LPDWORD lpReserved,             // \ς
	  LPDWORD lpcSubKeys,             // TuL[̐
	  LPDWORD lpcMaxSubKeyLen,        // TuL[̍Œ̒
	  LPDWORD lpcMaxClassLen,         // NX̍Œ̒
	  LPDWORD lpcValues,              // WXgGg̐
	  LPDWORD lpcMaxValueNameLen,     // WXgGg̍Œ̒
	  LPDWORD lpcMaxValueLen,         // WXgGg̃f[^̍Œ̒
	  LPDWORD lpcbSecurityDescriptor, // ZLeBLqq̒
	  PFILETIME lpftLastWriteTime     // Ō̏ݎ
	);
	 */
	@_CharSet(CHARSET)
	class Arg_RegQueryInfoKey {
		private int _LastError;
		
		private int hKey;
		private String lpClass = null;
		private int[] lpcClass = null;
		private int[] lpReserved = null;
		private int[] lpcSubKeys = new int[1];
		private int[] lpcMaxSubKeyLen = new int[1];
		private int[] lpcMaxClassLen = null;
		private int[] lpcValues = new int[1];
		private int[] lpcMaxValueNameLen = new int[1];
		private int[] lpcMaxValueLen = null;
		private int[] lpcbSecurityDescriptor = null;
		private long[] lpftLastWriteTime = null;
		
		Arg_RegQueryInfoKey(int hKey) {
			this.hKey = hKey;
		}
		int getSubKeys() {return lpcSubKeys[0];}
		int getMaxSubKeyLen() {return lpcMaxSubKeyLen[0];}
		int getValues() {return lpcValues[0];}
		int getMaxValueNameLen() {return lpcMaxValueNameLen[0];}
		int getLastError() {return _LastError;}
	}
	
	/*
	LONG RegOpenKeyEx(
	  HKEY hKey,         // JĂeL[̃nh
	  LPCTSTR lpSubKey,  // JׂTuL[̖O
	  DWORD ulOptions,   // \ς
	  REGSAM samDesired, // ZLeBANZX}XN
	  PHKEY phkResult    // JƂɐTuL[̃nh
	);
	 */
	@_CharSet(CHARSET)
	class Arg_RegOpenKeyEx {
		private int _LastError;
		
		private int hKey;
		private @_Const String lpSubKey;
		private int ulOptions = 0;
		private int samDesired = WinNT_h.KEY_READ;
		private int[] phkResult = new int[1];
		
		Arg_RegOpenKeyEx(int hKey, String lpSubKey) {
			this.hKey = hKey;
			this.lpSubKey = lpSubKey;
		}
		int gethkResult() {return phkResult[0];}
		int getLastError() {return _LastError;}
	}

	/*
	LONG RegCloseKey(
	  HKEY hKey   // ׂL[̃nh
	);
	 */
	class Arg_RegCloseKey {
		private int _LastError;
		
		private int hKey;
		
		Arg_RegCloseKey(int hKey) {
			this.hKey = hKey;
		}
		int getLastError() {return _LastError;}
	}
	
	class WinNT_h {
		static final int KEY_QUERY_VALUE        = 0x1;
		static final int KEY_SET_VALUE          = 0x2;
		static final int KEY_CREATE_SUB_KEY     = 0x4;
		static final int KEY_ENUMERATE_SUB_KEYS = 0x8;
		static final int KEY_NOTIFY             = 0x10;
		static final int KEY_CREATE_LINK        = 0x20;

		static final int READ_CONTROL            = 0x00020000;
		static final int STANDARD_RIGHTS_READ    = (READ_CONTROL);
		static final int STANDARD_RIGHTS_WRITE   = (READ_CONTROL);
		static final int STANDARD_RIGHTS_EXECUTE = (READ_CONTROL);
		static final int STANDARD_RIGHTS_ALL     = 0x001F0000;
		static final int SYNCHRONIZE             = 0x00100000;
		
		static final int KEY_READ = ((STANDARD_RIGHTS_READ | KEY_QUERY_VALUE 
				| KEY_ENUMERATE_SUB_KEYS | KEY_NOTIFY) & (~SYNCHRONIZE));
		static final int KEY_WRITE = ((STANDARD_RIGHTS_WRITE | KEY_SET_VALUE 
				| KEY_CREATE_SUB_KEY) & (~SYNCHRONIZE));
		static final int KEY_EXECUTE = ((KEY_READ) & (~SYNCHRONIZE));
		static final int KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL | KEY_QUERY_VALUE 
				| KEY_SET_VALUE | KEY_CREATE_SUB_KEY | KEY_ENUMERATE_SUB_KEYS | KEY_NOTIFY
				| KEY_CREATE_LINK) & (~SYNCHRONIZE));

		static final int REG_NONE                       = 0;
		static final int REG_SZ                         = 1;
		static final int REG_EXPAND_SZ                  = 2;
		static final int REG_BINARY                     = 3;
		static final int REG_DWORD                      = 4;
		static final int REG_DWORD_LITTLE_ENDIAN        = 4;
		static final int REG_DWORD_BIG_ENDIAN           = 5;
		static final int REG_LINK                       = 6;
		static final int REG_MULTI_SZ                   = 7;
		static final int REG_RESOURCE_LIST              = 8;
		static final int REG_FULL_RESOURCE_DESCRIPTOR   = 9;
		static final int REG_RESOURCE_REQUIREMENTS_LIST = 10;
		static final int REG_QWORD                      = 11;// 64-bit number
	}
	
	class WinReg_h {
		static final int HKEY_CLASSES_ROOT     = 0x80000000;
		static final int HKEY_CURRENT_USER     = 0x80000001;
		static final int HKEY_LOCAL_MACHINE    = 0x80000002;
		static final int HKEY_USERS            = 0x80000003;
		static final int HKEY_PERFORMANCE_DATA = 0x80000004;
		static final int HKEY_CURRENT_CONFIG   = 0x80000005;
		static final int HKEY_DYN_DATA         = 0x80000006;
	}
}