package testw32apianno;
import utildll.*;
public class TestW32API3 {
	final static int CHARSET = Arg.UNICODE;
	//final static int CHARSET = Arg.ANSI;

	public static void main(String[] args) {
		new TestW32API3();
	}
	
	TestW32API3() {
		Arg_EnumWindows aew = new Arg_EnumWindows(new Func_EnumWndProc(), 123);

		int intRtnVal = JInvoker.callIntProc("EnumWindows", "user32", aew);

		System.out.println("EnumWindows rtn: " + Integer.toString(intRtnVal)
			+ " LastError: " + Integer.toString(aew.getLastError())
			+ " lParam: " + aew.getlParam());
	}
}

/*
BOOL EnumWindows(
  WNDENUMPROC lpEnumFunc,  // R[obN֐
  LPARAM lParam            // AvP[V`̒l
);
 */
@_CharSet(TestW32API3.CHARSET)
class Arg_EnumWindows {
	private int _LastError;
	
	private @_FuncPtr Func_EnumWndProc lpEnumFunc;
	private int lParam;
	
	Arg_EnumWindows(Func_EnumWndProc lpEnumFunc, int lParam) {
		this.lpEnumFunc = lpEnumFunc;
		this.lParam = lParam;
	}
	int getLastError() {return _LastError;}
	int getlParam() {return lParam;}
}

class Func_EnumWndProc {
	private String _FuncName = "EnumWndProc";
	private int _ReturnType = Func.RTNTYPE_BOOLEAN;
	private Arg_EnumWndProc _FuncArg = new Arg_EnumWndProc();
	private ClsEnumWndProc _Instance = new ClsEnumWndProc();
	//private String _ClassName = "testw32apianno.ClsStaticEnumWndProc";
}

/*
BOOL CALLBACK EnumWindowsProc(
  HWND hwnd,      // eEBhẼnh
  LPARAM lParam   // AvP[V`̒l
);
 */
class Arg_EnumWndProc {
	private int hwnd;
	private int lParam;
	
	int gethwnd() {return hwnd;}
	int getlParam() {return lParam;}
}

class ClsEnumWndProc {
	boolean EnumWndProc(Arg_EnumWndProc aewp) {
		Arg_GetWindowTextLength agwtl = new Arg_GetWindowTextLength(aewp.gethwnd());
		
		int intTextLen = JInvoker.callIntProc("GetWindowTextLength", "user32", agwtl);
		
		Arg_GetWindowText agwt = new Arg_GetWindowText(aewp.gethwnd(), intTextLen + 1);
		
		int intText = JInvoker.callIntProc("GetWindowText", "user32", agwt);
		
		System.out.println("EnumWndProc hwnd:" + Integer.toHexString(aewp.gethwnd())
				+ " lParam:" + aewp.getlParam() + " WindowText:" + agwt.getText());
		
		return true;
	}
}

class ClsStaticEnumWndProc {
	static boolean EnumWndProc(Arg_EnumWndProc aewp) {
		Arg_GetWindowTextLength agwtl = new Arg_GetWindowTextLength(aewp.gethwnd());
		
		int intTextLen = JInvoker.callIntProc("GetWindowTextLength", "user32", agwtl);
		
		Arg_GetWindowText agwt = new Arg_GetWindowText(aewp.gethwnd(), intTextLen + 1);
		
		int intText = JInvoker.callIntProc("GetWindowText", "user32", agwt);
		
		System.out.println("static EnumWndProc hwnd:" + Integer.toHexString(aewp.gethwnd())
				+ " lParam:" + aewp.getlParam() + " WindowText:" + agwt.getText());
		
		return true;
	}
}

/*
int GetWindowTextLength(
  HWND hWnd   // EBhE܂̓Rg[̃nh
);
 */
@_CharSet(TestW32API3.CHARSET)
class Arg_GetWindowTextLength {
	private int hwnd;
	
	Arg_GetWindowTextLength(int hwnd){
		this.hwnd = hwnd;
	}
}

/*
int GetWindowText(
  HWND hWnd,        // EBhE܂̓Rg[̃nh
  LPTSTR lpString,  // eLXgobt@
  int nMaxCount     // Rs[ő啶
);
 */
@_CharSet(TestW32API3.CHARSET)
class Arg_GetWindowText {
	private int hwnd;
	private String lpsz;
	private int nChars;

	Arg_GetWindowText(int hwnd ,int nChars){
		this.hwnd = hwnd;
		StringBuffer sb = new StringBuffer(nChars);
		for (int i = 0; i < nChars; i++) {
			sb.append(' ');
		}
		this.lpsz = sb.toString();
		this.nChars = nChars;
	}
	String getText() {return lpsz;}
}


