package testw32apianno;
import utildll.*;
public class TestW32API8 {
	static final int CHARSET = Arg.UNICODE;
	//static final int CHARSET = Arg.ANSI;
	
	public static void main(String[] args) {
		new TestW32API8();
	}
	
	TestW32API8() {
		boolean blRtnVal;
		
		Arg_GetVolumeInformation agvi = new Arg_GetVolumeInformation("C:\\", 50, 50);
		
		blRtnVal = JInvoker.callBooleanProc("GetVolumeInformation", "kernel32", agvi);
		
		System.out.println("GetVolumeInformation rtn: " + Boolean.toString(blRtnVal)
				+ " LastError: " + Integer.toString(agvi.getLastError()));
		System.out.println("lpVolumeNameBuffer: " + agvi.getVolumeName());
		System.out.println("lpVolumeSerialNumber: " + Integer.toHexString(agvi.getVolumeSerialNumber()));
		System.out.println("lpMaximumComponentLength: " + Integer.toString(agvi.getMaximumComponentLength()));
		System.out.println("lpFileSystemFlags: " + Integer.toHexString(agvi.getFileSystemFlags()));
		System.out.println("lpFileSystemNameBuffer: " + agvi.getFileSystemName());
		
		
		Arg_GetDiskFreeSpaceEx agdfse = new Arg_GetDiskFreeSpaceEx("C:\\");
		
		blRtnVal = JInvoker.callBooleanProc("GetDiskFreeSpaceEx", "kernel32", agdfse);
		
		System.out.println("GetDiskFreeSpaceEx rtn: " + Boolean.toString(blRtnVal)
				+ " LastError: " + Integer.toString(agdfse.getLastError()));
		System.out.println("lpFreeBytesAvailable: " + Long.toString(agdfse.getFreeBytesAvailable()));
		System.out.println("lpTotalNumberOfBytes: " + Long.toString(agdfse.getTotalNumberOfBytes()));
		System.out.println("lpTotalNumberOfFreeBytes: " + Long.toString(agdfse.getTotalNumberOfFreeBytes()));
	
	}
	
	/*
	BOOL GetVolumeInformation(
	  LPCTSTR lpRootPathName,           // [gfBNg
	  LPTSTR lpVolumeNameBuffer,        // {[obt@
	  DWORD nVolumeNameSize,            // Oobt@̃TCY
	  LPDWORD lpVolumeSerialNumber,     // {[̃VAԍ
	  LPDWORD lpMaximumComponentLength, // t@C̍ő̒
	  LPDWORD lpFileSystemFlags,        // t@CVXẽIvV
	  LPTSTR lpFileSystemNameBuffer,    // t@CVXei[obt@
	  DWORD nFileSystemNameSize         // t@CVXei[obt@̃TCY
	);
	 */
	@_CharSet(CHARSET)
	class Arg_GetVolumeInformation {
		private int _LastError;
		
		private @_Const String lpRootPathName;
		private String lpVolumeNameBuffer;
		private int nVolumeNameSize;
		private int[] lpVolumeSerialNumber = new int[1];
		private int[] lpMaximumComponentLength = new int[1];
		private int[] lpFileSystemFlags = new int[1];
		private String lpFileSystemNameBuffer;
		private int nFileSystemNameSize;

		Arg_GetVolumeInformation(String lpRootPathName, int nVolumeNameSize, int nFileSystemNameSize) {
			this.lpRootPathName = lpRootPathName;
			StringBuffer sb = new StringBuffer(nVolumeNameSize);
			for (int i = 0; i < nVolumeNameSize; i++) {
				sb.append(' ');
			}
			this.lpVolumeNameBuffer = sb.toString();
			this.nVolumeNameSize = nVolumeNameSize;
			sb = new StringBuffer(nFileSystemNameSize);
			for (int i = 0; i < nFileSystemNameSize; i++) {
				sb.append(' ');
			}
			this.lpFileSystemNameBuffer = sb.toString();
			this.nFileSystemNameSize = nFileSystemNameSize;
		}
		String getVolumeName() {return lpVolumeNameBuffer;}
		int getVolumeSerialNumber() {return lpVolumeSerialNumber[0];}
		int getMaximumComponentLength() {return lpMaximumComponentLength[0];}
		int getFileSystemFlags() {return lpFileSystemFlags[0];}
		String getFileSystemName() {return lpFileSystemNameBuffer;}
		int getLastError() {return _LastError;}
	}
	
	/*
	BOOL GetDiskFreeSpaceEx(
	  LPCTSTR lpDirectoryName,                 // fBNg
	  PULARGE_INTEGER lpFreeBytesAvailable,    // ĂяopłoCg
	  PULARGE_INTEGER lpTotalNumberOfBytes,    // fBXNŜ̃oCg
	  PULARGE_INTEGER lpTotalNumberOfFreeBytes // fBXNŜ̋󂫃oCg
	);
	 */
	@_CharSet(CHARSET)
	class Arg_GetDiskFreeSpaceEx {
		private int _LastError;
		
		private @_Const String lpDirectoryName;
		private long[] lpFreeBytesAvailable = new long[1];
		private long[] lpTotalNumberOfBytes = new long[1];
		private long[] lpTotalNumberOfFreeBytes = new long[1];

		Arg_GetDiskFreeSpaceEx(String lpDirectoryName) {
			this.lpDirectoryName = lpDirectoryName;
		}
		long getFreeBytesAvailable() {return lpFreeBytesAvailable[0];}
		long getTotalNumberOfBytes() {return lpTotalNumberOfBytes[0];}
		long getTotalNumberOfFreeBytes() {return lpTotalNumberOfFreeBytes[0];}
		int getLastError() {return _LastError;}
	}
}
