package testw32apinew;

public class ExDispid_h {
	/*
	//
	// Dispatch IDS for IExplorer Dispatch Events.
	//
	#define DISPID_BEFORENAVIGATE     100   // this is sent before navigation to give a chance to abort
	#define DISPID_NAVIGATECOMPLETE   101   // in async, this is sent when we have enough to show
	#define DISPID_STATUSTEXTCHANGE   102
	#define DISPID_QUIT               103
	#define DISPID_DOWNLOADCOMPLETE   104
	#define DISPID_COMMANDSTATECHANGE 105
	#define DISPID_DOWNLOADBEGIN      106
	#define DISPID_NEWWINDOW          107   // sent when a new window should be created
	#define DISPID_PROGRESSCHANGE     108   // sent when download progress is updated
	#define DISPID_WINDOWMOVE         109   // sent when main window has been moved
	#define DISPID_WINDOWRESIZE       110   // sent when main window has been sized
	#define DISPID_WINDOWACTIVATE     111   // sent when main window has been activated
	#define DISPID_PROPERTYCHANGE     112   // sent when the PutProperty method is called
	#define DISPID_TITLECHANGE        113   // sent when the document title changes
	#define DISPID_TITLEICONCHANGE    114   // sent when the top level window icon may have changed.
	
	#define DISPID_FRAMEBEFORENAVIGATE    200
	#define DISPID_FRAMENAVIGATECOMPLETE  201
	#define DISPID_FRAMENEWWINDOW         204
	
	#define DISPID_BEFORENAVIGATE2              250           // hyperlink clicked on
	#define DISPID_NEWWINDOW2                   251
	#define DISPID_NAVIGATECOMPLETE2            252           // UIActivate new document
	#define DISPID_ONQUIT                       253
	#define DISPID_ONVISIBLE                    254           // sent when the window goes visible/hidden
	#define DISPID_ONTOOLBAR                    255           // sent when the toolbar should be shown/hidden
	#define DISPID_ONMENUBAR                    256           // sent when the menubar should be shown/hidden
	#define DISPID_ONSTATUSBAR                  257           // sent when the statusbar should be shown/hidden
	#define DISPID_ONFULLSCREEN                 258           // sent when kiosk mode should be on/off
	#define DISPID_DOCUMENTCOMPLETE             259           // new document goes ReadyState_Complete
	#define DISPID_ONTHEATERMODE                260           // sent when theater mode should be on/off
	#define DISPID_ONADDRESSBAR                 261           // sent when the address bar should be shown/hidden
	#define DISPID_WINDOWSETRESIZABLE           262           // sent to set the style of the host window frame
	#define DISPID_WINDOWCLOSING                263           // sent before script window.close closes the window 
	#define DISPID_WINDOWSETLEFT                264           // sent when the put_left method is called on the WebOC
	#define DISPID_WINDOWSETTOP                 265           // sent when the put_top method is called on the WebOC
	#define DISPID_WINDOWSETWIDTH               266           // sent when the put_width method is called on the WebOC
	#define DISPID_WINDOWSETHEIGHT              267           // sent when the put_height method is called on the WebOC 
	#define DISPID_CLIENTTOHOSTWINDOW           268           // sent during window.open to request conversion of dimensions
	#define DISPID_SETSECURELOCKICON            269           // sent to suggest the appropriate security icon to show
	#define DISPID_FILEDOWNLOAD                 270           // Fired to indicate the File Download dialog is opening
	#define DISPID_NAVIGATEERROR                271           // Fired to indicate the a binding error has occured
	#define DISPID_PRIVACYIMPACTEDSTATECHANGE   272           // Fired when the user's browsing experience is impacted
	#define DISPID_NEWWINDOW3                   273
	#define DISPID_VIEWUPDATE                   281           // Fired when the contents of a shell browser window change
	#define DISPID_SETPHISHINGFILTERSTATUS      282           // Fired by the Phishing Filter API to signal what state the analysis is in
	#define DISPID_WINDOWSTATECHANGED           283           // Fired to indicate that the browser window's visibility or enabled state has changed
	 */
	static final int  DISPID_BEFORENAVIGATE     = 100;   // this is sent before navigation to give a chance to abort
	static final int  DISPID_NAVIGATECOMPLETE   = 101;   // in async, this is sent when we have enough to show
	static final int  DISPID_STATUSTEXTCHANGE   = 102;
	static final int  DISPID_QUIT               = 103;
	static final int  DISPID_DOWNLOADCOMPLETE   = 104;
	static final int  DISPID_COMMANDSTATECHANGE = 105;
	static final int  DISPID_DOWNLOADBEGIN      = 106;
	static final int  DISPID_NEWWINDOW          = 107;   // sent when a new window should be created
	static final int  DISPID_PROGRESSCHANGE     = 108;   // sent when download progress is updated
	static final int  DISPID_WINDOWMOVE         = 109;   // sent when main window has been moved
	static final int  DISPID_WINDOWRESIZE       = 110;   // sent when main window has been sized
	static final int  DISPID_WINDOWACTIVATE     = 111;   // sent when main window has been activated
	static final int  DISPID_PROPERTYCHANGE     = 112;   // sent when the PutProperty method is called
	static final int  DISPID_TITLECHANGE        = 113;   // sent when the document title changes
	static final int  DISPID_TITLEICONCHANGE    = 114;   // sent when the top level window icon may have changed.
	
	static final int  DISPID_FRAMEBEFORENAVIGATE    = 200;
	static final int  DISPID_FRAMENAVIGATECOMPLETE  = 201;
	static final int  DISPID_FRAMENEWWINDOW         = 204;
	
	static final int  DISPID_BEFORENAVIGATE2              = 250;           // hyperlink clicked on
	static final int  DISPID_NEWWINDOW2                   = 251;
	static final int  DISPID_NAVIGATECOMPLETE2            = 252;           // UIActivate new document
	static final int  DISPID_ONQUIT                       = 253;
	static final int  DISPID_ONVISIBLE                    = 254;           // sent when the window goes visible/hidden
	static final int  DISPID_ONTOOLBAR                    = 255;           // sent when the toolbar should be shown/hidden
	static final int  DISPID_ONMENUBAR                    = 256;           // sent when the menubar should be shown/hidden
	static final int  DISPID_ONSTATUSBAR                  = 257;           // sent when the statusbar should be shown/hidden
	static final int  DISPID_ONFULLSCREEN                 = 258;           // sent when kiosk mode should be on/off
	static final int  DISPID_DOCUMENTCOMPLETE             = 259;           // new document goes ReadyState_Complete
	static final int  DISPID_ONTHEATERMODE                = 260;           // sent when theater mode should be on/off
	static final int  DISPID_ONADDRESSBAR                 = 261;           // sent when the address bar should be shown/hidden
	static final int  DISPID_WINDOWSETRESIZABLE           = 262;           // sent to set the style of the host window frame
	static final int  DISPID_WINDOWCLOSING                = 263;           // sent before script window.close closes the window 
	static final int  DISPID_WINDOWSETLEFT                = 264;           // sent when the put_left method is called on the WebOC
	static final int  DISPID_WINDOWSETTOP                 = 265;           // sent when the put_top method is called on the WebOC
	static final int  DISPID_WINDOWSETWIDTH               = 266;           // sent when the put_width method is called on the WebOC
	static final int  DISPID_WINDOWSETHEIGHT              = 267;           // sent when the put_height method is called on the WebOC 
	static final int  DISPID_CLIENTTOHOSTWINDOW           = 268;           // sent during window.open to request conversion of dimensions
	static final int  DISPID_SETSECURELOCKICON            = 269;           // sent to suggest the appropriate security icon to show
	static final int  DISPID_FILEDOWNLOAD                 = 270;           // Fired to indicate the File Download dialog is opening
	static final int  DISPID_NAVIGATEERROR                = 271;           // Fired to indicate the a binding error has occured
	static final int  DISPID_PRIVACYIMPACTEDSTATECHANGE   = 272;           // Fired when the user's browsing experience is impacted
	static final int  DISPID_NEWWINDOW3                   = 273;
	static final int  DISPID_VIEWUPDATE                   = 281;           // Fired when the contents of a shell browser window change
	static final int  DISPID_SETPHISHINGFILTERSTATUS      = 282;           // Fired by the Phishing Filter API to signal what state the analysis is in
	static final int  DISPID_WINDOWSTATECHANGED           = 283;           // Fired to indicate that the browser window's visibility or enabled state has changed
}
