package testw32apinew;
import utildll.*;

/*
 * VARIANT STRUCTURE
 *
 *  VARTYPE vt;
 *  WORD wReserved1;
 *  WORD wReserved2;
 *  WORD wReserved3;
 *  union {
 *    LONGLONG       VT_I8
 *    LONG           VT_I4
 *    BYTE           VT_UI1
 *    SHORT          VT_I2
 *    FLOAT          VT_R4
 *    DOUBLE         VT_R8
 *    VARIANT_BOOL   VT_BOOL
 *    SCODE          VT_ERROR
 *    CY             VT_CY
 *    DATE           VT_DATE
 *    BSTR           VT_BSTR
 *    IUnknown *     VT_UNKNOWN
 *    IDispatch *    VT_DISPATCH
 *    SAFEARRAY *    VT_ARRAY
 *    BYTE *         VT_BYREF|VT_UI1
 *    SHORT *        VT_BYREF|VT_I2
 *    LONG *         VT_BYREF|VT_I4
 *    LONGLONG *     VT_BYREF|VT_I8
 *    FLOAT *        VT_BYREF|VT_R4
 *    DOUBLE *       VT_BYREF|VT_R8
 *    VARIANT_BOOL * VT_BYREF|VT_BOOL
 *    SCODE *        VT_BYREF|VT_ERROR
 *    CY *           VT_BYREF|VT_CY
 *    DATE *         VT_BYREF|VT_DATE
 *    BSTR *         VT_BYREF|VT_BSTR
 *    IUnknown **    VT_BYREF|VT_UNKNOWN
 *    IDispatch **   VT_BYREF|VT_DISPATCH
 *    SAFEARRAY **   VT_BYREF|VT_ARRAY
 *    VARIANT *      VT_BYREF|VT_VARIANT
 *    PVOID          VT_BYREF (Generic ByRef)
 *    CHAR           VT_I1
 *    USHORT         VT_UI2
 *    ULONG          VT_UI4
 *    ULONGLONG      VT_UI8
 *    INT            VT_INT
 *    UINT           VT_UINT
 *    DECIMAL *      VT_BYREF|VT_DECIMAL
 *    CHAR *         VT_BYREF|VT_I1
 *    USHORT *       VT_BYREF|VT_UI2
 *    ULONG *        VT_BYREF|VT_UI4
 *    ULONGLONG *    VT_BYREF|VT_UI8
 *    INT *          VT_BYREF|VT_INT
 *    UINT *         VT_BYREF|VT_UINT
 *  }

typedef  struct tagVARIANT VARIANT;

struct tagVARIANT
    {
    union 
        {
        struct __tagVARIANT
            {
            VARTYPE vt;
            WORD wReserved1;
            WORD wReserved2;
            WORD wReserved3;
            union 
                {
                LONGLONG llVal;
                LONG lVal;
                BYTE bVal;
                SHORT iVal;
                FLOAT fltVal;
                DOUBLE dblVal;
                VARIANT_BOOL boolVal;
                _VARIANT_BOOL bool;
                SCODE scode;
                CY cyVal;
                DATE date;
                BSTR bstrVal;
                IUnknown *punkVal;
                IDispatch *pdispVal;
                SAFEARRAY *parray;
                BYTE *pbVal;
                SHORT *piVal;
                LONG *plVal;
                LONGLONG *pllVal;
                FLOAT *pfltVal;
                DOUBLE *pdblVal;
                VARIANT_BOOL *pboolVal;
                _VARIANT_BOOL *pbool;
                SCODE *pscode;
                CY *pcyVal;
                DATE *pdate;
                BSTR *pbstrVal;
                IUnknown **ppunkVal;
                IDispatch **ppdispVal;
                SAFEARRAY **pparray;
                VARIANT *pvarVal;
                PVOID byref;
                CHAR cVal;
                USHORT uiVal;
                ULONG ulVal;
                ULONGLONG ullVal;
                INT intVal;
                UINT uintVal;
                DECIMAL *pdecVal;
                CHAR *pcVal;
                USHORT *puiVal;
                ULONG *pulVal;
                ULONGLONG *pullVal;
                INT *pintVal;
                UINT *puintVal;
                struct __tagBRECORD
                    {
                    PVOID pvRecord;
                    IRecordInfo *pRecInfo;
                    } 	__VARIANT_NAME_4;
                } 	__VARIANT_NAME_3;
            } 	__VARIANT_NAME_2;
        DECIMAL decVal;
        } 	__VARIANT_NAME_1;
    } ;
 */
public class Struct_VARIANT {
	short vt;
	short wReserved1 = 0;
	short wReserved2 = 0;
	short wReserved3 = 0;
	@_Fixed @_Switch_is("vt") Union_VARIANT_NAME_3 uvn3 = new Union_VARIANT_NAME_3();
	
	public Struct_VARIANT() {
		this.vt = WTypes_h.VT_EMPTY;
		this.uvn3._Switch = this.vt;
	}
	public Struct_VARIANT(int lVal) {
		this.vt = WTypes_h.VT_I4;
		this.uvn3._Switch = this.vt;
		this.uvn3.lVal = lVal;
	}
	public Struct_VARIANT(long llVal) {
		this.vt = WTypes_h.VT_I8;
		this.uvn3._Switch = this.vt;
		this.uvn3.llVal = llVal;
	}
	public Struct_VARIANT(byte bVal) {
		this.vt = WTypes_h.VT_UI1;
		this.uvn3._Switch = this.vt;
		this.uvn3.bVal = bVal;
	}
	public Struct_VARIANT(short iVal) {
		this.vt = WTypes_h.VT_I2;
		this.uvn3._Switch = this.vt;
		this.uvn3.iVal = iVal;
	}
	public Struct_VARIANT(float fltVal) {
		this.vt = WTypes_h.VT_R4;
		this.uvn3._Switch = this.vt;
		this.uvn3.fltVal = fltVal;
	}
	public Struct_VARIANT(double dblVal) {
		this.vt = WTypes_h.VT_R8;
		this.uvn3._Switch = this.vt;
		this.uvn3.dblVal = dblVal;
	}
	public Struct_VARIANT(boolean boolVal) {
		this.vt = WTypes_h.VT_BOOL;
		this.uvn3._Switch = this.vt;
		this.uvn3.boolVal = boolVal ? (short)-1 : (short)0;
	}
	public Struct_VARIANT(String bstrVal) {
		this.vt = WTypes_h.VT_BSTR;
		this.uvn3._Switch = this.vt;
		this.uvn3.bstrVal = bstrVal;
	}
	
	public Struct_VARIANT(int i, int vt) {
		this.vt = (short)vt;
		this.uvn3._Switch = this.vt;

		switch(vt) {
		case WTypes_h.VT_I4:
			this.uvn3.lVal = i;
			break;
		case WTypes_h.VT_ERROR:
			this.uvn3.scode = i;
			break;
		case WTypes_h.VT_UNKNOWN:
			this.uvn3.punkVal = i;
			break;
		case WTypes_h.VT_DISPATCH:
			this.uvn3.pdispVal = i;
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_I4:
			this.uvn3.plVal = new int[]{i};
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_ERROR:
			this.uvn3.pscode = new int[]{i};
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_UNKNOWN:
			this.uvn3.ppunkVal = new int[]{i};
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_DISPATCH:
			this.uvn3.ppdispVal = new int[]{i};
			break;
		case WTypes_h.VT_BYREF:
			this.uvn3.byref = i;
			break;
		case WTypes_h.VT_UI4:
			this.uvn3.ulVal = i;
			break;
		case WTypes_h.VT_INT:
			this.uvn3.intVal = i;
			break;
		case WTypes_h.VT_UINT:
			this.uvn3.uintVal = i;
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_UI4:
			this.uvn3.pulVal = new int[]{i};
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_INT:
			this.uvn3.pintVal = new int[]{i};
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_UINT:
			this.uvn3.puintVal = new int[]{i};
			break;
		}
	}
	
	public Struct_VARIANT(byte b, int vt) {
		this.vt = (short)vt;
		this.uvn3._Switch = this.vt;

		switch(vt) {
		case WTypes_h.VT_UI1:
			this.uvn3.bVal = b;
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_UI1:
			this.uvn3.pbVal = new byte[]{b};
			break;
		case WTypes_h.VT_I1:
			this.uvn3.cVal = b;
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_I1:
			this.uvn3.pcVal = new byte[]{b};
			break;
		}
	}
	
	public Struct_VARIANT(short s, int vt) {
		this.vt = (short)vt;
		this.uvn3._Switch = this.vt;

		switch(vt) {
		case WTypes_h.VT_I2:
			this.uvn3.iVal = s;
			break;
		case WTypes_h.VT_BOOL:
			this.uvn3.boolVal = s;
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_I2:
			this.uvn3.piVal = new short[]{s};
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_BOOL:
			this.uvn3.pboolVal = new short[]{s};
			break;
		case WTypes_h.VT_UI2:
			this.uvn3.uiVal = s;
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_UI2:
			this.uvn3.puiVal = new short[]{s};
			break;
		}
	}
	
	public Struct_VARIANT(long l, int vt) {
		this.vt = (short)vt;
		this.uvn3._Switch = this.vt;

		switch(vt) {
		case WTypes_h.VT_I8:
			this.uvn3.llVal = l;
			break;
		case WTypes_h.VT_CY:
			this.uvn3.cyVal = l;
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_I8:
			this.uvn3.pllVal = new long[]{l};
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_CY:
			this.uvn3.pcyVal = new long[]{l};
			break;
		case WTypes_h.VT_UI8:
			this.uvn3.ullVal = l;
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_UI8:
			this.uvn3.pullVal = new long[]{l};
			break;
		}
	}
	
	public Struct_VARIANT(float f, int vt) {
		this.vt = (short)vt;
		this.uvn3._Switch = this.vt;

		switch(vt) {
		case WTypes_h.VT_R4:
			this.uvn3.fltVal = f;
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_R4:
			this.uvn3.pfltVal = new float[]{f};
			break;
		}
	}
	
	public Struct_VARIANT(double d, int vt) {
		this.vt = (short)vt;
		this.uvn3._Switch = this.vt;

		switch(vt) {
		case WTypes_h.VT_R8:
			this.uvn3.dblVal = d;
			break;
		case WTypes_h.VT_DATE:
			this.uvn3.date = d;
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_R8:
			this.uvn3.pdblVal = new double[]{d};
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_DATE:
			this.uvn3.pdate = new double[]{d};
			break;
		}
	}
	
	public Struct_VARIANT(boolean boolVal, int vt) {
		this.vt = (short)vt;
		this.uvn3._Switch = this.vt;

		switch(vt) {
		case WTypes_h.VT_BOOL:
			this.uvn3.boolVal = boolVal ? (short)-1 : (short)0;
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_BOOL:
			this.uvn3.pboolVal = new short[]{boolVal ? (short)-1 : (short)0};
			break;
		}
	}
	
	public Struct_VARIANT(String s, int vt) {
		this.vt = (short)vt;
		this.uvn3._Switch = this.vt;

		switch(vt) {
		case WTypes_h.VT_BSTR:
			this.uvn3.bstrVal = s;
			break;
		case WTypes_h.VT_BYREF | WTypes_h.VT_BSTR:
			this.uvn3.pbstrVal = new REF_BSTR(s);
			break;
		}
	}
}

class Union_VARIANT_NAME_3 {
	int _Switch;
	@_Case(WTypes_h.VT_I8)
		long llVal; //LONGLONG llVal;
	@_Case(WTypes_h.VT_I4)
		int lVal; //LONG lVal;
	@_Case(WTypes_h.VT_UI1)
		byte bVal; //BYTE bVal;
	@_Case(WTypes_h.VT_I2)
		short iVal; //SHORT iVal;
	@_Case(WTypes_h.VT_R4)
		float fltVal; //FLOAT fltVal;
	@_Case(WTypes_h.VT_R8)
		double dblVal; //DOUBLE dblVal;
	@_Case(WTypes_h.VT_BOOL)
		short boolVal; //VARIANT_BOOL boolVal;
	//@_Case(WTypes_h.VT_BOOL)
	//	short bool; //_VARIANT_BOOL bool;
	@_Case(WTypes_h.VT_ERROR)
		int scode; //SCODE scode;
	@_Case(WTypes_h.VT_CY)
		long cyVal; //CY cyVal;
	@_Case(WTypes_h.VT_DATE)
		double date; //DATE *pdate;
	@_Case(WTypes_h.VT_BSTR)
		@_BStr String bstrVal; //BSTR bstrVal;
	@_Case(WTypes_h.VT_UNKNOWN)
		int punkVal; //IUnknown *punkVal;
	@_Case(WTypes_h.VT_DISPATCH)
		int pdispVal; //IDispatch *pdispVal;
	@_Case(WTypes_h.VT_SAFEARRAY)
		Struct_SAFEARRAY parray; //SAFEARRAY *parray;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_UI1)
		byte[] pbVal; //BYTE *pbVal;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_I2)
		short[] piVal; //SHORT *piVal;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_I4)
		int[] plVal; //LONG *plVal;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_I8)
		long[] pllVal; //LONGLONG *pllVal;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_R4)
		float[] pfltVal; //FLOAT *pfltVal;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_R8)
		double[] pdblVal; //DOUBLE *pdblVal;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_BOOL)
		short[] pboolVal; //VARIANT_BOOL *pboolVal;
	//@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_BOOL)
	//	short[] pbool; //_VARIANT_BOOL *pbool;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_ERROR)
		int[] pscode; //SCODE *pscode;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_CY)
		long[] pcyVal; //CY *pcyVal;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_DATE)
		double[] pdate; //DATE *pdate;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_BSTR)
		REF_BSTR pbstrVal; //BSTR *pbstrVal;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_UNKNOWN)
		int[] ppunkVal; //IUnknown **ppunkVal;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_DISPATCH)
		int[] ppdispVal; //IDispatch **ppdispVal;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_SAFEARRAY)
		REF_SAFEARRAY pparray; //SAFEARRAY **pparray;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_VARIANT )
		Struct_VARIANT pvarVal; //VARIANT *pvarVal;
	@_Case(WTypes_h.VT_BYREF)
		int byref;//PVOID byref;
	@_Case(WTypes_h.VT_I1)
		byte cVal; //CHAR cVal;
	@_Case(WTypes_h.VT_UI2)
		short uiVal; //USHORT uiVal;
	@_Case(WTypes_h.VT_UI4)
		int ulVal; //ULONG ulVal;
	@_Case(WTypes_h.VT_UI8)
		long ullVal; //ULONGLONG ullVal;
	@_Case(WTypes_h.VT_INT)
		int intVal; //INT intVal;
	@_Case(WTypes_h.VT_UINT)
		int uintVal; //UINT uintVal;
	@_Case(WTypes_h.VT_BYREF | WTypes_h.VT_DECIMAL)
		Struct_DECIMAL pdecVal; //DECIMAL *pdecVal;
    @_Case(WTypes_h.VT_BYREF | WTypes_h.VT_I1)
    	byte[] pcVal; //CHAR *pcVal;
    @_Case(WTypes_h.VT_BYREF | WTypes_h.VT_UI2)
    	short[] puiVal; //USHORT *puiVal;
    @_Case(WTypes_h.VT_BYREF | WTypes_h.VT_UI4)
    	int[] pulVal; //ULONG *pulVal;
    @_Case(WTypes_h.VT_BYREF | WTypes_h.VT_UI8)
    	long[] pullVal; //ULONGLONG *pullVal;
    @_Case(WTypes_h.VT_BYREF | WTypes_h.VT_INT)
    	int[] pintVal; //INT *pintVal;
    @_Case(WTypes_h.VT_BYREF | WTypes_h.VT_UINT)
    	int[] puintVal; //UINT *puintVal;
}

class REF_BSTR {
	@_BStr String bs;
	REF_BSTR(String bs) {
		this.bs = bs;
	}
}

class REF_SAFEARRAY {
	Struct_SAFEARRAY ssa;
}

